//: C11:ToastOMaticMarkII.cpp {RunByHand}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Řešení problémů pomocí TQueue
//{L} ZThread
#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include "zthread/Thread.h"
#include "zthread/Mutex.h"
#include "zthread/Guard.h"
#include "zthread/Condition.h"
#include "zthread/ThreadedExecutor.h"
#include "TQueue.h"
using namespace ZThread;
using namespace std;

class Topinka {
  enum Stav { SUCHA, S_MASLEM, S_MARMELADOU };
  Stav stav;
  int id;
public:
  Topinka(int idn) : stav(SUCHA), id(idn) {}
  #ifdef __DMC__ // nesprávně vyžaduje výchozí
  Topinka() { assert(0); } // Nemělo by se nikdy zavolat
  #endif
  void maslo() { stav = S_MASLEM; }
  void marmelada() { stav = S_MARMELADOU; }
  string zjistiStav() const {
    switch(stav) {
      case SUCHA: return "suchá";
      case S_MASLEM: return "s máslem";
      case S_MARMELADOU: return "s marmeládou";
      default: return "Chyba";
    }
  }
  int getId() { return id; }
  friend ostream& operator<<(ostream& os, const Topinka& t) {
    return os << "Topinka " << t.id << ": " << t.zjistiStav();
  }
};

typedef CountedPtr< TQueue<Topinka> > FrontaTopinek;

class Topinkovac : public Runnable {
  FrontaTopinek frontaTopinek;
  int pocet;
public:
  Topinkovac(FrontaTopinek& tq) : frontaTopinek(tq), pocet(0) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        int zpozdeni = rand()/(RAND_MAX/5)*100;
        Thread::sleep(zpozdeni);
        // upéct topinku
        Topinka t(pocet++);
        cout << t << endl;
        // Přidat do fronty
        frontaTopinek->put(t);
      }
    } catch(Interrupted_Exception&) { /* Konec */ }
    cout << "Nedopečená topinka" << endl;
  }
};

// Namaže máslo na topinku:
class Maslo : public Runnable {
  FrontaTopinek frontaSuchych, frontaNamazanych;
public:
  Maslo(FrontaTopinek& sucha, FrontaTopinek& sMaslem)
  : frontaSuchych(sucha), frontaNamazanych(sMaslem) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        // Zablokováno dokud není k dispozici další topinka
        Topinka t = frontaSuchych->get();
        t.maslo();
        cout << t << endl;
        frontaNamazanych->put(t);
      }
    } catch(Interrupted_Exception&) { /* Konec */ }
    cout << "Bez másla" << endl;
  }
};

// Namazat marmeládu na topinku s máslem:
class Marmelada : public Runnable {
  FrontaTopinek frontaNamazanych, frontaHotovych;
public:
  Marmelada(FrontaTopinek& sMaslem, FrontaTopinek& hotova)
  : frontaNamazanych(sMaslem), frontaHotovych(hotova) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        // Zablokováno dokud není k dispozici další topinka
        Topinka t = frontaNamazanych->get();
        t.marmelada();
        cout << t << endl;
        frontaHotovych->put(t);
      }
    } catch(Interrupted_Exception&) { /* Konec */ }
    cout << "bez Marmelády" << endl;
  }
};

// Jí topinky:
class Jedlik : public Runnable {
  FrontaTopinek frontaHotovych;
  int pocitadlo;
public:
  Jedlik(FrontaTopinek& hotova)
  : frontaHotovych(hotova), pocitadlo(0) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        // Zablokováno dokud není k dispozici další topinka:
        Topinka t = frontaHotovych->get();
        // Ověřuje, že topinky jdou ve správném pořadí
        // a že jsou všechny s marmeládou:
        if(t.getId() != pocitadlo++ ||
           t.zjistiStav() != "s marmeládou") {
          cout << ">>>> Chyba: " << t << endl;
          exit(1);
        } else
          cout << "Chramst! " << t << endl;
      }
    } catch(Interrupted_Exception&) { /* Konec */ }
    cout << "Dojedeno" << endl;
  }
};

int main() {
  srand(time(0)); // Inicializovat generátor náhodných čísel
  try {
    FrontaTopinek frontaSuchych(new TQueue<Topinka>),
               frontaNamazanych(new TQueue<Topinka>),
               frontaHotovych(new TQueue<Topinka>);
    cout << "Konec stiskem klávesy <Enter>" << endl;
    ThreadedExecutor executor;
    executor.execute(new Topinkovac(frontaSuchych));
    executor.execute(new Maslo(frontaSuchych,frontaNamazanych));
    executor.execute(
      new Marmelada(frontaNamazanych, frontaHotovych));
    executor.execute(new Jedlik(frontaHotovych));
    cin.get();
    executor.interrupt();
  } catch(Synchronization_Exception& e) {
    cerr << e.what() << endl;
  }
} ///:~
